
#include <stdio.h>
#include "spnhdr.h"
#include "fstrmhdr.h"

extern float get_float () ;

typedef float  SITE   [N_SPIN] [N_COL] [2] ;
typedef double BILINS [N_BILS] [2] ;

static void get_site (site, rec)
SITE site ;
int rec [] ;
{
  site [0] [0] [0] = get_float (rec [ 0]) ;
  site [0] [0] [1] = get_float (rec [ 1]) ;
  site [0] [1] [0] = get_float (rec [ 2]) ;
  site [0] [1] [1] = get_float (rec [ 3]) ;
  site [0] [2] [0] = get_float (rec [ 4]) ;
  site [0] [2] [1] = get_float (rec [ 5]) ;
  site [1] [0] [0] = get_float (rec [ 6]) ;
  site [1] [0] [1] = get_float (rec [ 7]) ;
  site [1] [1] [0] = get_float (rec [ 8]) ;
  site [1] [1] [1] = get_float (rec [ 9]) ;
  site [1] [2] [0] = get_float (rec [10]) ;
  site [1] [2] [1] = get_float (rec [11]) ;
  site [2] [0] [0] = get_float (rec [12]) ;
  site [2] [0] [1] = get_float (rec [13]) ;
  site [2] [1] [0] = get_float (rec [14]) ;
  site [2] [1] [1] = get_float (rec [15]) ;
  site [2] [2] [0] = get_float (rec [16]) ;
  site [2] [2] [1] = get_float (rec [17]) ;
  site [3] [0] [0] = get_float (rec [18]) ;
  site [3] [0] [1] = get_float (rec [19]) ;
  site [3] [1] [0] = get_float (rec [20]) ;
  site [3] [1] [1] = get_float (rec [21]) ;
  site [3] [2] [0] = get_float (rec [22]) ;
  site [3] [2] [1] = get_float (rec [23]) ;
}
  
static void cpy_site (site2, site1)
SITE site1, site2 ;
{
  int i, j ;

  for (i = 0; i < N_SPIN; i++)
    for (j = 0; j < N_COL; j++)
    {
      site2 [i] [j] [0] = site1 [i] [j] [0] ;
      site2 [i] [j] [1] = site1 [i] [j] [1] ;
    }
}

static void site_bilins (bilins, site1, site2)
BILINS bilins ;
SITE   site1, site2 ;
{
  bilins [0] [0] =
    ((site1 [0] [0] [0] * site2 [0] [0] [0])  +
     (site1 [0] [0] [1] * site2 [0] [0] [1])) +
    ((site1 [0] [1] [0] * site2 [0] [1] [0])  +
     (site1 [0] [1] [1] * site2 [0] [1] [1])) +
    ((site1 [0] [2] [0] * site2 [0] [2] [0])  +
     (site1 [0] [2] [1] * site2 [0] [2] [1])) ;
  bilins [0] [1] =
    ((site1 [0] [0] [0] * site2 [0] [0] [1])  -
     (site1 [0] [0] [1] * site2 [0] [0] [0])) +
    ((site1 [0] [1] [0] * site2 [0] [1] [1])  -
     (site1 [0] [1] [1] * site2 [0] [1] [0])) +
    ((site1 [0] [2] [0] * site2 [0] [2] [1])  -
     (site1 [0] [2] [1] * site2 [0] [2] [0])) ;
  bilins [1] [0] =
    ((site1 [0] [0] [0] * site2 [1] [0] [0])  +
     (site1 [0] [0] [1] * site2 [1] [0] [1])) +
    ((site1 [0] [1] [0] * site2 [1] [1] [0])  +
     (site1 [0] [1] [1] * site2 [1] [1] [1])) +
    ((site1 [0] [2] [0] * site2 [1] [2] [0])  +
     (site1 [0] [2] [1] * site2 [1] [2] [1])) ;
  bilins [1] [1] =
    ((site1 [0] [0] [0] * site2 [1] [0] [1])  -
     (site1 [0] [0] [1] * site2 [1] [0] [0])) +
    ((site1 [0] [1] [0] * site2 [1] [1] [1])  -
     (site1 [0] [1] [1] * site2 [1] [1] [0])) +
    ((site1 [0] [2] [0] * site2 [1] [2] [1])  -
     (site1 [0] [2] [1] * site2 [1] [2] [0])) ;
  bilins [2] [0] =
    ((site1 [1] [0] [0] * site2 [0] [0] [0])  +
     (site1 [1] [0] [1] * site2 [0] [0] [1])) +
    ((site1 [1] [1] [0] * site2 [0] [1] [0])  +
     (site1 [1] [1] [1] * site2 [0] [1] [1])) +
    ((site1 [1] [2] [0] * site2 [0] [2] [0])  +
     (site1 [1] [2] [1] * site2 [0] [2] [1])) ;
  bilins [2] [1] =
    ((site1 [1] [0] [0] * site2 [0] [0] [1])  -
     (site1 [1] [0] [1] * site2 [0] [0] [0])) +
    ((site1 [1] [1] [0] * site2 [0] [1] [1])  -
     (site1 [1] [1] [1] * site2 [0] [1] [0])) +
    ((site1 [1] [2] [0] * site2 [0] [2] [1])  -
     (site1 [1] [2] [1] * site2 [0] [2] [0])) ;
  bilins [3] [0] =
    ((site1 [1] [0] [0] * site2 [1] [0] [0])  +
     (site1 [1] [0] [1] * site2 [1] [0] [1])) +
    ((site1 [1] [1] [0] * site2 [1] [1] [0])  +
     (site1 [1] [1] [1] * site2 [1] [1] [1])) +
    ((site1 [1] [2] [0] * site2 [1] [2] [0])  +
     (site1 [1] [2] [1] * site2 [1] [2] [1])) ;
  bilins [3] [1] =
    ((site1 [1] [0] [0] * site2 [1] [0] [1])  -
     (site1 [1] [0] [1] * site2 [1] [0] [0])) +
    ((site1 [1] [1] [0] * site2 [1] [1] [1])  -
     (site1 [1] [1] [1] * site2 [1] [1] [0])) +
    ((site1 [1] [2] [0] * site2 [1] [2] [1])  -
     (site1 [1] [2] [1] * site2 [1] [2] [0])) ;
  bilins [4] [0] =
    ((site1 [2] [0] [0] * site2 [2] [0] [0])  +
     (site1 [2] [0] [1] * site2 [2] [0] [1])) +
    ((site1 [2] [1] [0] * site2 [2] [1] [0])  +
     (site1 [2] [1] [1] * site2 [2] [1] [1])) +
    ((site1 [2] [2] [0] * site2 [2] [2] [0])  +
     (site1 [2] [2] [1] * site2 [2] [2] [1])) ;
  bilins [4] [1] =
    ((site1 [2] [0] [0] * site2 [2] [0] [1])  -
     (site1 [2] [0] [1] * site2 [2] [0] [0])) +
    ((site1 [2] [1] [0] * site2 [2] [1] [1])  -
     (site1 [2] [1] [1] * site2 [2] [1] [0])) +
    ((site1 [2] [2] [0] * site2 [2] [2] [1])  -
     (site1 [2] [2] [1] * site2 [2] [2] [0])) ;
  bilins [5] [0] =
    ((site1 [2] [0] [0] * site2 [3] [0] [0])  +
     (site1 [2] [0] [1] * site2 [3] [0] [1])) +
    ((site1 [2] [1] [0] * site2 [3] [1] [0])  +
     (site1 [2] [1] [1] * site2 [3] [1] [1])) +
    ((site1 [2] [2] [0] * site2 [3] [2] [0])  +
     (site1 [2] [2] [1] * site2 [3] [2] [1])) ;
  bilins [5] [1] =
    ((site1 [2] [0] [0] * site2 [3] [0] [1])  -
     (site1 [2] [0] [1] * site2 [3] [0] [0])) +
    ((site1 [2] [1] [0] * site2 [3] [1] [1])  -
     (site1 [2] [1] [1] * site2 [3] [1] [0])) +
    ((site1 [2] [2] [0] * site2 [3] [2] [1])  -
     (site1 [2] [2] [1] * site2 [3] [2] [0])) ;
  bilins [6] [0] =
    ((site1 [3] [0] [0] * site2 [2] [0] [0])  +
     (site1 [3] [0] [1] * site2 [2] [0] [1])) +
    ((site1 [3] [1] [0] * site2 [2] [1] [0])  +
     (site1 [3] [1] [1] * site2 [2] [1] [1])) +
    ((site1 [3] [2] [0] * site2 [2] [2] [0])  +
     (site1 [3] [2] [1] * site2 [2] [2] [1])) ;
  bilins [6] [1] =
    ((site1 [3] [0] [0] * site2 [2] [0] [1])  -
     (site1 [3] [0] [1] * site2 [2] [0] [0])) +
    ((site1 [3] [1] [0] * site2 [2] [1] [1])  -
     (site1 [3] [1] [1] * site2 [2] [1] [0])) +
    ((site1 [3] [2] [0] * site2 [2] [2] [1])  -
     (site1 [3] [2] [1] * site2 [2] [2] [0])) ;
  bilins [7] [0] =
    ((site1 [3] [0] [0] * site2 [3] [0] [0])  +
     (site1 [3] [0] [1] * site2 [3] [0] [1])) +
    ((site1 [3] [1] [0] * site2 [3] [1] [0])  +
     (site1 [3] [1] [1] * site2 [3] [1] [1])) +
    ((site1 [3] [2] [0] * site2 [3] [2] [0])  +
     (site1 [3] [2] [1] * site2 [3] [2] [1])) ;
  bilins [7] [1] =
    ((site1 [3] [0] [0] * site2 [3] [0] [1])  -
     (site1 [3] [0] [1] * site2 [3] [0] [0])) +
    ((site1 [3] [1] [0] * site2 [3] [1] [1])  -
     (site1 [3] [1] [1] * site2 [3] [1] [0])) +
    ((site1 [3] [2] [0] * site2 [3] [2] [1])  -
     (site1 [3] [2] [1] * site2 [3] [2] [0])) ;
}

void sums (data1, data2, l_time, l_space)
int l_time, l_space ;
FDATA *data1, *data2 ;
{
  int t, x ;

  for (t = 0; t < l_time; t++)
  {
    int i ;
    BILINS accum ;

    for (i = 0; i < N_BILS; i++)
    {
      accum [i] [0] = 0.0 ;
      accum [i] [1] = 0.0 ;
    }

    for (x = 0; x < l_space; x++)
    {
      int *rec1, *rec2 ;
      SITE   site1, site2 ;
      BILINS bilins ;

      fdata_read_field_record (data1, site1) ;
      if (data2 != data1)
      {
	fdata_read_field_record (data2, site2) ;
      }
      else
	cpy_site (site2, site1) ;

      site_bilins (bilins, site1, site2) ;

      for (i = 0; i < N_BILS; i++)
      {
	accum [i] [0] += bilins [i] [0] ;
	accum [i] [1] += bilins [i] [1] ;
      }
    }
    for (i = 0; i < N_BILS; i++)
      fprintf (stdout, "%g %g\n", accum [i] [0], accum [i] [1]) ;
    fprintf (stdout, "\n") ;
  }
}

